/*
 * Device Motion Gesture for JavaScript.
 * http://sourceforge.net/projects/jsmotiongesture/
 * http://www.lucidviews.net/software/jsmotiongesture/
 * 
 * This library is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; version 3 of the License.
 * 
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU General Public License along
 * with the files in this library. If not, see  http://www.gnu.org/licenses
 * Distributed under the GNU Library or Lesser General Public License (LGPL)
 */

if(typeof Motion==="undefined"){Motion={}
}Motion.Model={};
Motion.Model.MotionDataBuffer=function(b,a,c){this.data=b;
this.timeSpan=a;
this.autoTruncate=c
};
Motion.Model.MotionDataBuffer.prototype.setTimeSpan=function(a){this.timeSpan=a
};
Motion.Model.MotionDataBuffer.prototype.setAutoTruncate=function(a){this.autoTruncate=a
};
Motion.Model.MotionDataBuffer.prototype.setData=function(a){this.data.metadata=(a.metadata)?a.metadata:Motion.Model.MotionDataBuffer.newMetadata();
this.data.x=a.x;
this.data.y=a.y;
this.data.z=a.z;
this.data.xg=a.xg;
this.data.yg=a.yg;
this.data.zg=a.zg
};
Motion.Model.MotionDataBuffer.prototype.createCopy=function(){return Motion.Model.MotionDataBuffer.createCopy(this.data)
};
Motion.Model.MotionDataBuffer.prototype.clear=function(){this.data.metadata=Motion.Model.MotionDataBuffer.newMetadata();
this.clearAxis("x");
this.clearAxis("y");
this.clearAxis("z");
this.clearAxis("xg");
this.clearAxis("yg");
this.clearAxis("zg")
};
Motion.Model.MotionDataBuffer.prototype.clearAxis=function(b){var a=this.data[b];
a.values=[];
a.times=[]
};
Motion.Model.MotionDataBuffer.prototype.append=function(b,a){if(!this.data.metadata.record.endTime||b>this.data.metadata.record.endTime){this.data.metadata.record.endTime=b
}this.appendToAxis("x",b,a.x);
this.appendToAxis("y",b,a.y);
this.appendToAxis("z",b,a.z);
this.appendToAxis("xg",b,a.xg);
this.appendToAxis("yg",b,a.yg);
this.appendToAxis("zg",b,a.zg)
};
Motion.Model.MotionDataBuffer.prototype.appendToAxis=function(b,d,c){var a=this.data[b];
a.times[a.times.length]=d;
a.values[a.values.length]=c;
if(this.autoTruncate===true){this.truncate()
}};
Motion.Model.MotionDataBuffer.prototype.truncate=function(){this.truncateAxis("x");
this.truncateAxis("y");
this.truncateAxis("z");
this.truncateAxis("xg");
this.truncateAxis("yg");
this.truncateAxis("zg")
};
Motion.Model.MotionDataBuffer.prototype.truncateAxis=function(e){var c=this.data[e];
if(this.timeSpan&&c.times.length>1){var b=c.times[c.times.length-1];
var d=b-this.timeSpan;
var a=0;
while(c.times[a]<d){a++
}if(a>0){c.times.splice(0,a);
c.values.splice(0,a)
}}};
Motion.Model.MotionDataBuffer.prototype.dataAsJson=function(){if(!JSON){alert("Your browser does not support JSON processing. Please upgrade to a more recent browser.");
return null
}else{return JSON.stringify(this.data)
}};
Motion.Model.MotionDataBuffer.prototype.dataFromJson=function(a){if(!JSON){alert("Your browser does not support JSON processing. Please upgrade to a more recent browser.");
return null
}else{this.setData(JSON.parse(a))
}};
Motion.Model.MotionDataBuffer.prototype.iterate=function(a,d){var c=(d)?d:0;
var g=this.data.x.times.length;
for(var b=0;
b<g;
b++){var f=this.data.x.times[b];
if(f>c){var e={timestamp:f,x:this.data.x.values[b],y:this.data.y.values[b],z:this.data.z.values[b],xg:this.data.xg.values[b],yg:this.data.yg.values[b],zg:this.data.zg.values[b]};
a(e)
}}};
Motion.Model.MotionDataBuffer.newData=function(a){var b=(a)?a:Motion.Model.MotionDataBuffer.newMetadata();
return{metadata:b,x:Motion.Model.MotionDataBuffer.newAxisData(),y:Motion.Model.MotionDataBuffer.newAxisData(),z:Motion.Model.MotionDataBuffer.newAxisData(),xg:Motion.Model.MotionDataBuffer.newAxisData(),yg:Motion.Model.MotionDataBuffer.newAxisData(),zg:Motion.Model.MotionDataBuffer.newAxisData()}
};
Motion.Model.MotionDataBuffer.newMetadata=function(){return{record:{endTime:null}}
};
Motion.Model.MotionDataBuffer.newAxisData=function(){return{values:[],times:[]}
};
Motion.Model.MotionDataBuffer.createCopy=function(a){return{metadata:a.metadata,x:Motion.Model.MotionDataBuffer.createAxisCopy(a.x),y:Motion.Model.MotionDataBuffer.createAxisCopy(a.y),z:Motion.Model.MotionDataBuffer.createAxisCopy(a.z),xg:Motion.Model.MotionDataBuffer.createAxisCopy(a.xg),yg:Motion.Model.MotionDataBuffer.createAxisCopy(a.yg),zg:Motion.Model.MotionDataBuffer.createAxisCopy(a.zg)}
};
Motion.Model.MotionDataBuffer.createAxisCopy=function(a){return{values:Motion.Model.MotionDataBuffer.createArrayCopy(a.values),times:Motion.Model.MotionDataBuffer.createArrayCopy(a.times)}
};
Motion.Model.MotionDataBuffer.createArrayCopy=function(c){var b=[];
for(var a=0;
a<c.length;
a++){b[a]=c[a]
}return b
};
Motion.Model.MotionDataPump=function(){this.deviceMotionData=null;
this.readIntervals=[];
this.simulateWithRandomData=true;
var a=this;
var b=function(c){a.handleDeviceMotion(c)
};
window.addEventListener("devicemotion",b,false)
};
Motion.Model.MotionDataPump.prototype.handleDeviceMotion=function(a){this.deviceMotionData={x:a.acceleration.x,y:a.acceleration.y,z:a.acceleration.z,xg:a.accelerationIncludingGravity.x,yg:a.accelerationIncludingGravity.y,zg:a.accelerationIncludingGravity.z}
};
Motion.Model.MotionDataPump.prototype.startReading=function(d,e){this.stopReading(d);
var a=this;
var c=function(){if(a.deviceMotionData){d.readMotionData(a.deviceMotionData)
}else{if(a.simulateWithRandomData){var f={x:10-(Math.random()*20),y:10-(Math.random()*20),z:10-(Math.random()*20),xg:10-(Math.random()*20),yg:10-(Math.random()*20),zg:10-(Math.random()*20)};
d.readMotionData(f)
}}};
var b=window.setInterval(c,e);
this.readIntervals[this.readIntervals.length]={interval:b,handler:d}
};
Motion.Model.MotionDataPump.prototype.stopReading=function(b){var a=0;
while(a<this.readIntervals.length){if(this.readIntervals[a].handler===b){window.clearInterval(this.readIntervals[a].interval);
this.readIntervals.splice(a,1)
}else{a++
}}};
Motion.Model.MotionDataPump.getInstance=function(){if(!Motion.Model.MotionDataPump.INSTANCE){Motion.Model.MotionDataPump.INSTANCE=new Motion.Model.MotionDataPump()
}return Motion.Model.MotionDataPump.INSTANCE
};
if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}Motion.Gesture.Model={};
Motion.Gesture.Model.Control={};
Motion.Gesture.Model.Control.getStartTime=function(b){if(b.previous){var a=Motion.Gesture.Model.Control.getStartTime(b.previous)+(b.previous.window.time.width/2);
return a+b.window.time.delay
}else{return b.window.time.start
}};
Motion.Gesture.Model.Gesture={};
Motion.Gesture.Model.Gesture.isDefined=function(a){return(a.signature)
};
Motion.Gesture.Model.Gesture.leadTime=function(e){var b=0;
for(var d=0;
d<e.signature.roots.length;
d++){var c=e.signature.roots[d];
if(c.next){var f=c.next;
var a=f.window.time.width;
if(a>b){b=a
}}}return b
};
Motion.Gesture.Model.RecognitionReport={};
Motion.Gesture.Model.RecognitionReport.readFromThread=function(e){var a={};
a.success=e.status.conditionMet;
a.start=e.startTime;
a.gesture=e.gesture;
a.controlResults=[];
for(var b=0;
b<e.controlThreads.length;
b++){var d=e.controlThreads[b];
var c={};
c.control=d.control;
c.success=d.status.conditionMet;
if(d.timeFrame){c.start=d.timeFrame.start;
c.on=d.timeFrame.on;
c.off=d.timeFrame.off
}a.controlResults[a.controlResults.length]=c
}return a
};
Motion.Gesture.Model.RecognitionReport.humanReadableJsonFilter=function(b,c){if(b==="gesture"){return undefined
}if(b==="controlResults"){var a=c;
var e=[];
for(var d in a){e[e.length]=a[d]
}return e
}return c
};
Motion.Gesture.Model.Serialisation={};
Motion.Gesture.Model.Serialisation.signatureFromJson=function(b){var a=JSON.parse(b);
Motion.Gesture.Model.Serialisation.restoreDeserialisedSignature(a);
return a
};
Motion.Gesture.Model.Serialisation.signatureToJson=function(a,b){return JSON.stringify(a,Motion.Gesture.Model.Serialisation.jsonSerialisationFilter,b)
};
Motion.Gesture.Model.Serialisation.jsonSerialisationFilter=function(a,b){if(a==="previous"){return undefined
}if(a==="signature"){return undefined
}return b
};
Motion.Gesture.Model.Serialisation.restoreDeserialisedSignature=function(a){for(var b=0;
b<a.roots.length;
b++){var c=a.roots[b];
while(c.next){c.next.previous=c;
c.signature=a;
c=c.next
}}};
if(typeof Motion==="undefined"){Motion={}
}if(typeof Motion.Gesture==="undefined"){Motion.Gesture={}
}Motion.Gesture.Recognition={};
Motion.Gesture.Recognition.ConditionComparator=function(){};
Motion.Gesture.Recognition.ConditionComparator.prototype.isRootControlConiditionMet=function(b,c){for(var a=0;
a<b.length;
a++){if(this.isControlConiditionMet(b[a],c)===false){return false
}}return true
};
Motion.Gesture.Recognition.ConditionComparator.prototype.isControlConiditionMet=function(c,b){for(var a=0;
a<c.points.length;
a++){if(this.isControlPointConiditionMet(c.points[a],b)===false){return false
}}return true
};
Motion.Gesture.Recognition.ConditionComparator.prototype.isControlPointConiditionMet=function(a,c){var b=c[a.axis];
if(b){return(b>a.window.value.min&&b<a.window.value.max)
}else{return false
}};
Motion.Gesture.Recognition.ControlThread=function(b,a){this.control=b;
this.conditionComparator=a;
this.status={};
this.status.expired=false;
this.status.conditionMet=false
};
Motion.Gesture.Recognition.ControlThread.prototype.start=function(b){var a=(b)?b:new Date().getTime();
this.timeFrame={};
this.timeFrame.start=a;
this.timeFrame.on=this.timeFrame.start+this.control.window.time.delay;
this.timeFrame.off=this.timeFrame.on+this.control.window.time.width
};
Motion.Gesture.Recognition.ControlThread.prototype.process=function(a){if(a.timestamp<this.timeFrame.on){return false
}if(a.timestamp>this.timeFrame.off){this.stop();
return true
}if(this.conditionComparator.isControlConiditionMet(this.control,a)===true){this.status.conditionMet=true;
this.stop();
return true
}return false
};
Motion.Gesture.Recognition.ControlThread.prototype.stop=function(){this.status.expired=true
};
Motion.Gesture.Recognition.GestureThread=function(a,b){this.gesture=a;
this.conditionComparator=b;
this.controlThreads=[];
this.status={};
this.status.expired=false;
this.status.conditionMet=false
};
Motion.Gesture.Recognition.GestureThread.prototype.start=function(b){this.startTime=(b)?b:new Date().getTime();
for(var a=0;
a<this.gesture.signature.roots.length;
a++){this.startMonitoringControl(this.gesture.signature.roots[a].next,this.startTime)
}};
Motion.Gesture.Recognition.GestureThread.prototype.startMonitoringControl=function(d,c){var b=(c)?c:null;
var a=new Motion.Gesture.Recognition.ControlThread(d,this.conditionComparator);
a.start(b);
this.controlThreads[this.controlThreads.length]=a
};
Motion.Gesture.Recognition.GestureThread.prototype.process=function(c){var e=false;
for(var b=0;
b<this.controlThreads.length;
b++){var d=this.controlThreads[b];
if(d.status.expired===false){var a=d.process(c);
if(a===true){e=true;
if(d.status.expired===true&&d.status.conditionMet&&d.control.next){this.startMonitoringControl(d.control.next,c.timestamp)
}}}}if(e===true){return this.updateStatus()
}else{return false
}};
Motion.Gesture.Recognition.GestureThread.prototype.updateStatus=function(){var a=false;
if(this.allThreadsExpired()===true){if(this.allControlsMet()===true){this.status.conditionMet=true
}this.stop();
a=true
}return a
};
Motion.Gesture.Recognition.GestureThread.prototype.allThreadsExpired=function(){for(var a=0;
a<this.controlThreads.length;
a++){if(this.controlThreads[a].status.expired===false){return false
}}return true
};
Motion.Gesture.Recognition.GestureThread.prototype.allControlsMet=function(){for(var a=0;
a<this.controlThreads.length;
a++){if(this.controlThreads[a].status.conditionMet===false){return false
}}return true
};
Motion.Gesture.Recognition.GestureThread.prototype.stop=function(){this.status.expired=true
};
Motion.Gesture.Recognition.Monitor=function(a){this.conditionComparator=(a)?a:new Motion.Gesture.Recognition.ConditionComparator();
this.gestures=[];
this.gestureTriggers={};
this.timeForNextDistinctGesture={};
this.reportListeners=[];
this.gestureThreads=[]
};
Motion.Gesture.Recognition.Monitor.prototype.addGesture=function(b,a){this.removeGesture(b);
this.gestures[this.gestures.length]=b;
this.gestureTriggers[b.id]=a
};
Motion.Gesture.Recognition.Monitor.prototype.removeGesture=function(a){this.stopThreadsForGesture(a);
this.gestureTriggers[a.id]=null;
var b=this.gestures.indexOf(a);
if(b>-1){this.gestures.splice(b,1)
}};
Motion.Gesture.Recognition.Monitor.prototype.stopAllThreads=function(){for(var a=0;
a<this.gestures.length;
a++){this.stopThreadsForGesture(this.gestures[a])
}};
Motion.Gesture.Recognition.Monitor.prototype.stopThreadsForGesture=function(c){for(var b=0;
b<this.gestureThreads.length;
b++){var a=this.gestureThreads[b];
if(a.gesture.id==c.id){a.stop()
}}this.dereferenceExpiredThreads()
};
Motion.Gesture.Recognition.Monitor.prototype.dereferenceExpiredThreads=function(){var c=0;
while(c<this.gestureThreads.length){var a=this.gestureThreads[c];
if(a.status.expired===true){if(this.hasReportListener()){var b=Motion.Gesture.Model.RecognitionReport.readFromThread(a);
this.notifyReportListeners(b)
}if(a.status.conditionMet===true&&!this.isDuplicateGestureThread(a)){var d=a.gesture.id;
this.gestureTriggers[d]()
}this.gestureThreads.splice(c,1)
}else{c++
}}};
Motion.Gesture.Recognition.Monitor.prototype.isDuplicateGestureThread=function(a){var b=a.gesture.id;
if(this.timeForNextDistinctGesture[b]&&a.startTime<this.timeForNextDistinctGesture[b]){return true
}else{this.timeForNextDistinctGesture[b]=a.startTime+Motion.Gesture.Model.Gesture.leadTime(a.gesture);
return false
}};
Motion.Gesture.Recognition.Monitor.prototype.process=function(a){this.processCurrentThreads(a);
this.processNewThreads(a)
};
Motion.Gesture.Recognition.Monitor.prototype.processCurrentThreads=function(c){var d=false;
for(var b=0;
b<this.gestureThreads.length;
b++){var a=this.gestureThreads[b].process(c);
if(a===true){d=true
}}if(d===true){this.dereferenceExpiredThreads()
}};
Motion.Gesture.Recognition.Monitor.prototype.processNewThreads=function(c){for(var b=0;
b<this.gestures.length;
b++){var a=this.gestures[b];
if(this.conditionComparator.isRootControlConiditionMet(a.signature.roots,c)===true){this.startMonitoringGesture(c.timestamp,a)
}}};
Motion.Gesture.Recognition.Monitor.prototype.startMonitoringGesture=function(c,b){var a=new Motion.Gesture.Recognition.GestureThread(b,this.conditionComparator);
a.start(c);
this.gestureThreads[this.gestureThreads.length]=a
};
Motion.Gesture.Recognition.Monitor.prototype.addReportListener=function(a){this.reportListeners[this.reportListeners.length]=a
};
Motion.Gesture.Recognition.Monitor.prototype.hasReportListener=function(){return this.reportListeners.length>0
};
Motion.Gesture.Recognition.Monitor.prototype.notifyReportListeners=function(a){for(var b=0;
b<this.reportListeners.length;
b++){this.reportListeners[b](a)
}};
Motion.Gesture.Recognition.MotionDataPump=function(a,b){this.monitor=a;
this.period=b
};
Motion.Gesture.Recognition.MotionDataPump.prototype.start=function(){Motion.Model.MotionDataPump.getInstance().startReading(this,this.period)
};
Motion.Gesture.Recognition.MotionDataPump.prototype.stop=function(){Motion.Model.MotionDataPump.getInstance().stopReading(this)
};
Motion.Gesture.Recognition.MotionDataPump.prototype.readMotionData=function(a){if(typeof a.timestamp==="undefined"){a.timestamp=new Date().getTime()
}this.monitor.process(a)
};